# coding: utf-8

"""
DrugCoverageApi.py
Copyright 2016 SmartBear Software

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
"""

from __future__ import absolute_import

import sys
import os

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class DrugCoverageApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def drugs_ndc_coverages_get(self, ndc, **kwargs):
        """
        Find Drug Coverages for a given NDC
        Drug Coverages are the specific tier level, quantity limit, prior authorization
and step therapy for a given Drug/Plan combination.  This endpoint returns
all DrugCoverages for a given Drug



        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.drugs_ndc_coverages_get(ndc, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str ndc: NDC for a drug (required)
        :return: list[DrugCoverage]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['ndc']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method drugs_ndc_coverages_get" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'ndc' is set
        if ('ndc' not in params) or (params['ndc'] is None):
            raise ValueError("Missing the required parameter `ndc` when calling `drugs_ndc_coverages_get`")

        resource_path = '/drugs/{ndc}/coverages'.replace('{format}', 'json')
        path_params = {}
        if 'ndc' in params:
            path_params['ndc'] = params['ndc']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept([])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = []

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='list[DrugCoverage]',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response
